//Land Nomad AOK style - hacked together by Democritus aka FerrariWarrior
//this is public domain, if you find/fix a bug please semd me new file with
//annotations where the bug was fixed, stephen.white@mindspring.com

void main(void)
{

   // Text
   rmSetStatusText("",0.10);

   for(i=1; <cNumberPlayers)
   {
      rmCreateTrigger("disableTechs"+i);
   }

   // disable starting units
   for(i=1; <cNumberPlayers)
   {
      rmSwitchToTrigger(rmTriggerID("disableTechs"+i));
      rmSetTriggerActive(true);

/* 0 = unobtainable, 1 = available, 2 = obtainable, 3 = obtainable, 4 = active */

      if(rmGetPlayerCulture(i) == cCultureGreek) 
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("TechID", "144");
         rmSetTriggerEffectParam("Status", "0"); /* unobtainable */

      }

      if(rmGetPlayerCulture(i) == cCultureNorse) 
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("TechID", "143");
         rmSetTriggerEffectParam("Status", "0");
      }   

      if(rmGetPlayerCulture(i) == cCultureEgyptian) 
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("TechID", "145");
         rmSetTriggerEffectParam("Status", "0");
      }

      if(rmGetPlayerCiv(i) == cCivThor) 
      {
         rmAddTriggerEffect("Set Tech Status");
         rmSetTriggerEffectParamInt("PlayerID", i);
         rmSetTriggerEffectParam("TechID", "380");
         rmSetTriggerEffectParam("Status", "0");
      }

      // Build TCs faster
      rmAddTriggerEffect("Set Tech Status");
      rmSetTriggerEffectParamInt("PlayerID", i);
      rmSetTriggerEffectParam("TechID", "386");
      rmSetTriggerEffectParam("Status", "4"); /* active */
      rmEchoInfo("Build TC faster");

   }

   
   rmCreateTrigger("Prevent Fighting");
   rmSetTriggerActive(true);

   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 15);

   rmAddTriggerEffect("Grant God Power");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("PowerName", "cease fire nomad");
   rmSetTriggerEffectParamInt("Count", 1);

   rmAddTriggerEffect("Invoke God Power");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("PowerName", "cease fire nomad");
   rmSetTriggerEffectParam("DstPoint1", "1,1,1");

   rmAddTriggerEffect("Send Chat");
   rmSetTriggerEffectParamInt("PlayerID", 0);
   rmSetTriggerEffectParam("Message", "{22556}");

   rmCreateTrigger("Dawn");
   rmCreateTrigger("Day");

   rmSwitchToTrigger(rmTriggerID("Dawn"));
   rmSetTriggerActive(true);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 60);
   rmAddTriggerEffect("Set Lighting");
   rmSetTriggerEffectParam("SetName", "Dawn");
   rmSetTriggerEffectParamInt("FadeTime", 30);
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParamInt("EventID", rmTriggerID("Day"));

   rmSwitchToTrigger(rmTriggerID("Day"));
   rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 120);
   rmAddTriggerEffect("Set Lighting");
   rmSetTriggerEffectParam("SetName", "Default");
   rmSetTriggerEffectParamInt("FadeTime", 30);


// ------------------------------------ END TRIGGERS -----------------------------------
// Set size.
   int playerTiles=9000;
   if(cMapSize == 1)
   {
      playerTiles = 11700;
      rmEchoInfo("Large map");
   }
   int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles/0.9);
   rmEchoInfo("Map size="+size+"m x "+size+"m");
   rmSetMapSize(size, size);

// Init map. 
   rmTerrainInitialize("GrassDirt25");
   rmSetLightingSet("night");

// Define some classes

int classPlayer=rmDefineClass("player");
rmDefineClass("corner");
rmDefineClass("classHill");
int classCliff=rmDefineClass("cliff");
rmDefineClass("starting settlement");

// Define constraints.

// edge of map

int edgeConstraint=rmCreateBoxConstraint("edge of map", rmXTilesToFraction(8), rmZTilesToFraction(8), 1.0-rmXTilesToFraction(8), 1.0-rmZTilesToFraction(8));

// player constraints
int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 30.0);
int shortPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a little", classPlayer, 10.0);

// corner constraint.
int cornerConstraint=rmCreateClassDistanceConstraint("stay away from corner", rmClassID("corner"), 15.0);
int cornerOverlapConstraint=rmCreateClassDistanceConstraint("don't overlap corner", rmClassID("corner"), 2.0);

// Settlement constraints
int shortAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by short distance", "AbstractSettlement", 20.0);
int mediumAvoidSettlement=rmCreateTypeDistanceConstraint("objects avoid TC by medium distance", "AbstractSettlement", 30.0);
int farAvoidSettlement=rmCreateTypeDistanceConstraint("TCs avoid TCs by long distance", "AbstractSettlement", 50.0);

// Gold constraint
int avoidGold=rmCreateTypeDistanceConstraint("avoid gold", "gold", 30.0);
int shortAvoidGold=rmCreateTypeDistanceConstraint("short avoid gold", "gold", 10.0);

// Food constraints 
int avoidHerdable=rmCreateTypeDistanceConstraint("avoid herdable", "herdable", 30.0);
int avoidFood=rmCreateTypeDistanceConstraint("avoid other food sources", "food", 6.0);

// impassable land constraint
int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "land", false, 10.0);
int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 10.0);
int shortCliffConstraint=rmCreateClassDistanceConstraint("stuff v cliff", rmClassID("cliff"), 10.0);
int mediumCliffConstraint=rmCreateClassDistanceConstraint("players v cliff", rmClassID("cliff"), 30.0);
int avoidStartingUnits=rmCreateTypeDistanceConstraint("avoid starting units", "unit", 40);
int avoidBuildings=rmCreateTypeDistanceConstraint("avoid buildings", "Building", 30.0);
int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);


// Define objects
// Close Objects

// Starting units
   int VillagerGreekID=rmCreateObjectDef("Villager Greek");
   rmAddObjectDefItem(VillagerGreekID, "Villager Greek", 1, 0.0);
   rmSetObjectDefMinDistance(VillagerGreekID, 0.0);
   rmSetObjectDefMaxDistance(VillagerGreekID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(VillagerGreekID, edgeConstraint);
   rmAddObjectDefConstraint(VillagerGreekID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(VillagerGreekID, avoidStartingUnits);
   rmAddObjectDefConstraint(VillagerGreekID, mediumCliffConstraint);

   int ScoutID=rmCreateObjectDef("Scout");
   rmAddObjectDefItem(ScoutID, "Scout", 1, 0.0);
   rmSetObjectDefMinDistance(ScoutID, 0.0);
   rmSetObjectDefMaxDistance(ScoutID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(ScoutID, edgeConstraint);
   rmAddObjectDefConstraint(ScoutID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(ScoutID, avoidStartingUnits);
   rmAddObjectDefConstraint(ScoutID, mediumCliffConstraint);

   int VillagerNorseID=rmCreateObjectDef("Villager norse");
   rmAddObjectDefItem(VillagerNorseID, "Villager norse", 1, 0.0);
   rmSetObjectDefMinDistance(VillagerNorseID, 0.0);
   rmSetObjectDefMaxDistance(VillagerNorseID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(VillagerNorseID, edgeConstraint);
   rmAddObjectDefConstraint(VillagerNorseID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(VillagerNorseID, avoidStartingUnits);
   rmAddObjectDefConstraint(VillagerNorseID, mediumCliffConstraint);

   int OxCartID=rmCreateObjectDef("Ox cart norse");
   rmAddObjectDefItem(OxCartID, "Ox cart", 1, 0.0);
   rmSetObjectDefMinDistance(OxCartID, 0.0);
   rmSetObjectDefMaxDistance(OxCartID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(OxCartID, edgeConstraint);
   rmAddObjectDefConstraint(OxCartID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(OxCartID, avoidStartingUnits);
   rmAddObjectDefConstraint(OxCartID, mediumCliffConstraint);

   int VillagerEgyptianID=rmCreateObjectDef("Villager Egyptian");
   rmAddObjectDefItem(VillagerEgyptianID, "Villager Egyptian", 1, 0.0);
   rmSetObjectDefMinDistance(VillagerEgyptianID, 0.0);
   rmSetObjectDefMaxDistance(VillagerEgyptianID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(VillagerEgyptianID, edgeConstraint);
   rmAddObjectDefConstraint(VillagerEgyptianID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(VillagerEgyptianID, avoidStartingUnits);
   rmAddObjectDefConstraint(VillagerEgyptianID, mediumCliffConstraint);

   int PharaohID=rmCreateObjectDef("Pharaoh");
   rmAddObjectDefItem(PharaohID, "Pharaoh", 1, 0.0);
   rmSetObjectDefMinDistance(PharaohID, 0.0);
   rmSetObjectDefMaxDistance(PharaohID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(PharaohID, edgeConstraint);
   rmAddObjectDefConstraint(PharaohID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(PharaohID, avoidStartingUnits);
   rmAddObjectDefConstraint(PharaohID, mediumCliffConstraint);

   int PriestID=rmCreateObjectDef("Priest");
   rmAddObjectDefItem(PriestID, "Priest", 1, 0.0);
   rmSetObjectDefMinDistance(PriestID, 0.0);
   rmSetObjectDefMaxDistance(PriestID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(PriestID, edgeConstraint);
   rmAddObjectDefConstraint(PriestID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(PriestID, avoidStartingUnits);
   rmAddObjectDefConstraint(PriestID, mediumCliffConstraint);

   int UlfsarkID=rmCreateObjectDef("Ulfsark");
   rmAddObjectDefItem(UlfsarkID, "Ulfsark", 1, 0.0);
   rmSetObjectDefMinDistance(UlfsarkID, 0.0);
   rmSetObjectDefMaxDistance(UlfsarkID, rmXFractionToMeters(0.25));
   rmAddObjectDefConstraint(UlfsarkID, edgeConstraint);
   rmAddObjectDefConstraint(UlfsarkID, mediumAvoidSettlement);
   rmAddObjectDefConstraint(UlfsarkID, avoidStartingUnits);
   rmAddObjectDefConstraint(UlfsarkID, mediumCliffConstraint);

   // Settlement avoids gold, Settlements
   int farSettlementID=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(farSettlementID, "Settlement", 1, 0.0);
   rmSetObjectDefMaxDistance(farSettlementID, rmAreaFractionToTiles(1.0));
   rmAddObjectDefConstraint(farSettlementID, edgeConstraint);
   rmAddObjectDefConstraint(farSettlementID, farAvoidSettlement);
   rmAddObjectDefConstraint(farSettlementID, avoidImpassableLand);

   // gold avoids gold
   int farGoldID=rmCreateObjectDef("far gold");
   rmAddObjectDefItem(farGoldID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(farGoldID, 80.0);
   rmSetObjectDefMaxDistance(farGoldID, 150.0);
   rmAddObjectDefConstraint(farGoldID, avoidGold);
   rmAddObjectDefConstraint(farGoldID, avoidImpassableLand);

   // gold avoids gold, Settlements and TCs
   int farGold2ID=rmCreateObjectDef("far gold 2");
   rmAddObjectDefItem(farGold2ID, "Gold mine", 1, 0.0);
   rmSetObjectDefMinDistance(farGold2ID, 80.0);
   rmSetObjectDefMaxDistance(farGold2ID, 150.0);
   rmAddObjectDefConstraint(farGold2ID, avoidGold);
   rmAddObjectDefConstraint(farGold2ID, avoidImpassableLand);

   // goats avoid TCs 
   int farGoatsID=rmCreateObjectDef("far goats");
   rmAddObjectDefItem(farGoatsID, "goat", 6, 4.0);
   rmSetObjectDefMinDistance(farGoatsID, 80.0);
   rmSetObjectDefMaxDistance(farGoatsID, 150.0);
   rmAddObjectDefConstraint(farGoatsID, avoidImpassableLand);
   rmAddObjectDefConstraint(farGoatsID, avoidHerdable);
   
   // Berries  
   int farBerriesID=rmCreateObjectDef("far berries");
   rmAddObjectDefItem(farBerriesID, "berry bush", 10, 4.0);
   rmSetObjectDefMinDistance(farBerriesID, 0.0);
   rmSetObjectDefMaxDistance(farBerriesID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(farBerriesID, avoidImpassableLand);
   rmAddObjectDefConstraint(farBerriesID, shortAvoidSettlement);
   rmAddObjectDefConstraint(farBerriesID, avoidFood);

   // extra meat
   int classBonusHuntable=rmDefineClass("bonus huntable");
   int avoidBonusHuntable=rmCreateClassDistanceConstraint("avoid bonus huntable", classBonusHuntable, 40.0);
   int avoidHuntable=rmCreateTypeDistanceConstraint("avoid huntable", "huntable", 20.0);

   // hunted avoids hunted and TCs
   int bonusHuntableID=rmCreateObjectDef("bonus huntable");
   rmAddObjectDefItem(bonusHuntableID, "deer", 8, 6.0);
   rmSetObjectDefMinDistance(bonusHuntableID, 0.0);
   rmSetObjectDefMaxDistance(bonusHuntableID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(bonusHuntableID, avoidBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, avoidHuntable);
   rmAddObjectDefToClass(bonusHuntableID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntableID, avoidImpassableLand);
   rmAddObjectDefConstraint(bonusHuntableID, avoidFood);

   // hunted 2 avoids hunted and TCs
   int bonusHuntable2ID=rmCreateObjectDef("second bonus huntable");
   rmAddObjectDefItem(bonusHuntable2ID, "boar", 6, 2.0);
   rmSetObjectDefMinDistance(bonusHuntable2ID, 0.0);
   rmSetObjectDefMaxDistance(bonusHuntable2ID, rmXFractionToMeters(0.5));
   rmAddObjectDefToClass(bonusHuntable2ID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntable2ID, avoidBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntable2ID, avoidHuntable);
   rmAddObjectDefToClass(bonusHuntable2ID, classBonusHuntable);
   rmAddObjectDefConstraint(bonusHuntable2ID, avoidImpassableLand);
   rmAddObjectDefConstraint(bonusHuntable2ID, avoidFood);

   
   // stragglers
   int randomTreeID=rmCreateObjectDef("random tree");
   rmAddObjectDefItem(randomTreeID, "oak tree", 1, 0.0);
   rmSetObjectDefMinDistance(randomTreeID, 0.0);
   rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomTreeID, rmCreateTypeDistanceConstraint("random tree", "all", 4.0));
   rmAddObjectDefConstraint(randomTreeID, shortAvoidSettlement);
   rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);

   int randomtree2ID=rmCreateObjectDef("random tree two");
   rmAddObjectDefItem(randomtree2ID, "oak tree", 1, 0.0);
   rmSetObjectDefMinDistance(randomtree2ID, 0.0);
   rmSetObjectDefMaxDistance(randomtree2ID, rmXFractionToMeters(0.5));
   rmAddObjectDefConstraint(randomtree2ID, rmCreateTypeDistanceConstraint("random tree 2", "all", 4.0));
   rmAddObjectDefConstraint(randomtree2ID, shortAvoidSettlement);
   rmAddObjectDefConstraint(randomtree2ID, avoidImpassableLand);

   // Relics avoid TCs
   int relicID=rmCreateObjectDef("relic");
   rmAddObjectDefItem(relicID, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(relicID, 60.0);
   rmSetObjectDefMaxDistance(relicID, 150.0);
   rmAddObjectDefConstraint(relicID, avoidImpassableLand);
   rmAddObjectDefConstraint(relicID, rmCreateTypeDistanceConstraint("relic vs relic", "relic", 70.0));
   rmAddObjectDefConstraint(relicID, shortAvoidSettlement);

//Done defining objects

rmSetTeamSpacingModifier(0.75);
rmPlacePlayersCircular(0.2, 0.4, rmDegreesToRadians(4.0));

// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(4000);
   for(i=1; <cNumberPlayers)
   {
      // Create the area.
      int id=rmCreateArea("Player"+i);

      // Assign to the player.
      rmSetPlayerArea(i, id);

      // Set the size.
      rmSetAreaSize(id, 0.9*playerFraction, 1.1*playerFraction);

      rmAddAreaToClass(id, classPlayer);
      rmSetAreaWarnFailure(id, false);

      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 5);
      rmSetAreaMinBlobDistance(id, 16.0);
      rmSetAreaMaxBlobDistance(id, 40.0);
      rmSetAreaCoherence(id, 0.0);

      //rmSetAreaBaseHeight(id, 4.0);

      // Add constraints.
      rmAddAreaConstraint(id, playerConstraint);
      rmAddAreaConstraint(id, edgeConstraint);


      // Set the location.
      rmSetAreaLocPlayer(id, i);

      // Set type.
      rmSetAreaTerrainType(id, "GrassDirt25");
   }

   // Build the areas.
   rmBuildAllAreas();


//Place objects

// Text
rmSetStatusText("",0.20);

// Settlements.
   rmPlaceObjectDefAtLoc(farSettlementID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*3);

//Elevation first
   
//Cliff
     
   int cliffConstraint=rmCreateClassDistanceConstraint("cliff v cliff", rmClassID("cliff"), 40.0);
   int failCount=0;
   
   for(i=0; <cNumberPlayers*1.5)
   {
      int cliffID=rmCreateArea("cliff"+i);
      rmSetAreaWarnFailure(cliffID, false);
      rmSetAreaSize(cliffID, rmAreaTilesToFraction(150), rmAreaTilesToFraction(300));
      rmSetAreaCliffType(cliffID, "Norse");
      rmAddAreaConstraint(cliffID, edgeConstraint);
      rmAddAreaConstraint(cliffID, cliffConstraint);
      rmAddAreaConstraint(cliffID, avoidImpassableLand);
      rmAddAreaToClass(cliffID, classCliff);
      rmAddAreaConstraint(cliffID, avoidBuildings);
      rmSetAreaMinBlobs(cliffID, 10);
      rmSetAreaMaxBlobs(cliffID, 10);
      rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.1, 1.0, 0);
      rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
      rmSetAreaCliffHeight(cliffID, 7, 1.0, 1.0);
      rmSetAreaMinBlobDistance(cliffID, 16.0);
      rmSetAreaMaxBlobDistance(cliffID, 40.0);
      rmSetAreaCoherence(cliffID, 0.25);
      rmSetAreaSmoothDistance(cliffID, 10);
      rmSetAreaHeightBlend(cliffID, 2);
    
      if(rmBuildArea(cliffID)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==3)
            break;
      }
      else
         failCount=0;
      
   }
   

// Elev.
   int numTries=10*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      int elevID=rmCreateArea("elev"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(80), rmAreaTilesToFraction(200));
      rmSetAreaLocation(elevID, rmRandFloat(0.0, 1.0), rmRandFloat(0.0, 1.0));
      rmSetAreaWarnFailure(elevID, false);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, shortCliffConstraint);
      rmAddAreaConstraint(elevID, avoidImpassableLand);
      if(rmRandFloat(0.0, 1.0)<0.5)
      rmSetAreaTerrainType(elevID, "GrassDirt25");  
      rmSetAreaBaseHeight(elevID, rmRandFloat(3.0, 4.0));

      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 5);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 40.0);
      rmSetAreaCoherence(elevID, 0.0);

      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 20 times in a row.
         failCount++;
         if(failCount==20)
            break;
      }
      else
         failCount=0;
   }

// Slight Elevation
   numTries=15*cNumberNonGaiaPlayers;
   failCount=0;
   for(i=0; <numTries)
   {
      elevID=rmCreateArea("wrinkle"+i);
      rmSetAreaSize(elevID, rmAreaTilesToFraction(80), rmAreaTilesToFraction(200));
      rmSetAreaWarnFailure(elevID, false);
      rmSetAreaBaseHeight(elevID, rmRandFloat(2.0, 4.0));
      rmSetAreaHeightBlend(elevID, 1);
      rmSetAreaMinBlobs(elevID, 1);
      rmSetAreaMaxBlobs(elevID, 3);
      rmSetAreaMinBlobDistance(elevID, 16.0);
      rmSetAreaMaxBlobDistance(elevID, 20.0);
      rmSetAreaCoherence(elevID, 0.0);
      rmAddAreaConstraint(elevID, avoidBuildings);
      rmAddAreaConstraint(elevID, shortCliffConstraint);
      rmAddAreaConstraint(elevID, shortHillConstraint);
      rmAddAreaConstraint(elevID, avoidImpassableLand);


      if(rmBuildArea(elevID)==false)
      {
         // Stop trying once we fail 10 times in a row.
         failCount++;
         if(failCount==10)
            break;
      }
      else
         failCount=0;
   }

// All other objects

  int playerculture = 0;

    for(i=0; <cNumberPlayers)
   {
      playerculture = rmGetPlayerCulture(i);
      rmEchoInfo("player "+i+" culture "+playerculture);      
         
   }  

   for(i=0; <cNumberPlayers)
   {
      if(rmGetPlayerCulture(i) == cCultureGreek)
         {
/*          rmPlaceObjectDefAtLoc(VillagerGreekID, i, 0.5, 0.5, 3); */
            rmPlaceObjectDefAtLoc(VillagerGreekID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 3);
            rmPlaceObjectDefAtLoc(ScoutID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
            rmEchoInfo("Placing Villagers for Player "+i+" who is "+rmGetPlayerCulture(i));

         }
      else if(rmGetPlayerCulture(i) == cCultureEgyptian)
         {
/*          rmPlaceObjectDefAtLoc(VillagerEgyptianID, i, 0.5, 0.5, 3); */
            rmPlaceObjectDefAtLoc(VillagerEgyptianID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 2);
            rmPlaceObjectDefAtLoc(PharaohID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
            rmPlaceObjectDefAtLoc(PriestID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
            rmEchoInfo("Placing Villagers for Player "+i+" who is "+rmGetPlayerCulture(i));


         }
      else if(rmGetPlayerCulture(i) == cCultureNorse)
         {
/*          rmPlaceObjectDefAtLoc(UlfsarkID, i, 0.5, 0.5, 2); */
            rmPlaceObjectDefAtLoc(UlfsarkID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
            rmPlaceObjectDefAtLoc(VillagerNorseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 2);
            rmPlaceObjectDefAtLoc(OxCartID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i), 1);
/*          rmPlaceObjectDefAtLoc(VillagerNorseID, i, 0.5, 0.5, 1); */
            rmEchoInfo("Placing Villagers for Player "+i+" who is "+rmGetPlayerCulture(i));

         }
   }
 
// Text
rmSetStatusText("",0.60);


   // Gold.
   rmPlaceObjectDefPerPlayer(farGoldID, false, 3);
   
   rmPlaceObjectDefPerPlayer(farGold2ID, false, 1);

   // Relics
   rmPlaceObjectDefPerPlayer(relicID, false);

   // Goats.
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefAtLoc(farGoatsID, 0, 0.5, 0.5, 3);

   // Berries.
   rmPlaceObjectDefAtLoc(farBerriesID, 0, 0.5, 0.5, cNumberPlayers*2);

   // Bonus huntable stuff.
   rmPlaceObjectDefAtLoc(bonusHuntableID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2);

   // Bonus huntable stuff.
   rmPlaceObjectDefAtLoc(bonusHuntable2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers);

   // Random trees.
   rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 20*cNumberNonGaiaPlayers);
   rmPlaceObjectDefAtLoc(randomtree2ID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);

int allObjConstraint=rmCreateTypeDistanceConstraint("all obj", "all", 6.0);

   // Forest.
   int classForest=rmDefineClass("forest");
   int forestConstraint=rmCreateClassDistanceConstraint("forest v forest", rmClassID("forest"), 30.0);
   failCount=0;
   numTries=12*cNumberNonGaiaPlayers;
   for(i=0; <numTries)
   {
      int forestID=rmCreateArea("forest"+i);
      rmSetAreaSize(forestID, rmAreaTilesToFraction(100), rmAreaTilesToFraction(200));
      rmSetAreaWarnFailure(forestID, false);
      rmSetAreaForestType(forestID, "autumn oak forest");
      rmAddAreaConstraint(forestID, allObjConstraint);
      rmAddAreaConstraint(forestID, forestConstraint);
      rmAddAreaConstraint(forestID, shortCliffConstraint);
      rmAddAreaToClass(forestID, classForest);
      
      rmSetAreaMinBlobs(forestID, 3);
      rmSetAreaMaxBlobs(forestID, 7);
      rmSetAreaMinBlobDistance(forestID, 16.0);
      rmSetAreaMaxBlobDistance(forestID, 40.0);
      rmSetAreaCoherence(forestID, 0.0);

      if(rmBuildArea(forestID)==false)
      {
         // Stop trying once we fail 6 times in a row.
         failCount++;
         if(failCount==6)
            break;
      }
      else
         failCount=0;
   }
}
